﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace XamDataChartInterpolatedTooltipCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public DispatcherTimer Timer { get; set; }

        Random r = new Random();

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            Timer = new DispatcherTimer();

            for (int i = 0; i < 20; i++)
            {
                Data.Add(new SampleData()
                {
                    Date = DateTime.Today.AddDays(i),
                    Value = r.Next(1,9)
                });
            }

            Timer.Interval = new TimeSpan(0, 0, 1);

            Timer.Tick += timer_Tick;

            Timer.Start();
        }


        int count = 0;
        void timer_Tick(object sender, EventArgs e)
        {

            Data.RemoveAt(0);

            count++;

            if (count % 2 == 0)
            {
                SampleData SD = new SampleData() { Date = Data.Last().Date.AddDays(1), Value = r.Next(1,9), InterpolatedValue = null };
                Data.Add(SD);

                int i = Data.IndexOf(SD);

                if (Data[i - 1].Value == null)
                {
                    Data[i - 1].InterpolatedValue = (Data[i - 2].Value + Data[i].Value) / 2;
                }
            }
            else
            {
                Data.Add(new SampleData()
                {
                    Date = Data.Last().Date.AddDays(1),
                    Value = null
                });
            }
        }
    }

    public class SampleData
    {
        public DateTime Date { get; set; }
        public int? Value { get; set; }
        public int? InterpolatedValue { get; set; }

    }
}
